;============================================
; PROGRAMMER DR. THIT SIRIBOON
; DATE       30/11/2537
; PURPOSE:  DISPLAY DECIMAL NUMBER FROM -128 TO 127
; ON SCREEN
;============================================
       .ORG  H'100
       LDAA  #-128      ; START WITH -128
MAIN:
       BSR   SHOWDEC    ; SHOW DECIMAL
       PSHA             ; SAVE NUMBER
       LDAA  #' '       ;---- DISPLAY BLANK
       JSR   H'F803     ;--|
       PULA             ; GET NUMBER
       INCA             ; NEXT NUMBER
       CMPA  #-128      ;---|
       BNE   MAIN       ;---- STOP AT 127
HERE:  BRA   HERE       ; JUST STAY HERE

;===========================================
; SUBROUTINE DIV10
; DIVIDE CONTENT OF ACC. BY 10
; INPUT:           BYTE IN ACC. A
; RETURN OUTPUT:   RESULT IN ACC. A
;                  REMAINDER IN ACC. B
; REGISTER CHANGE: ACC. A AND ACC. B
; MEMORY CHANGE:   NONE
; SIDE EFFECT:     NONE
;============================================


DIV10:
        TAB           ; MOVE NUMBER TO ACC. B
        CLRA          ; CLEAR A FOR COUNTING
TOP:
        CMPB  #9      ; IS NUMNER LESS THAN 10
        BLS   FINDIV  ; YES FINNISH
        INCA          ; COUNT COUNTER
        SUBB  #10     ; DIVIDE BY KEEP SUB. 10
        BRA   TOP
FINDIV:
        RTS

;===========================================
; SUBROUTINE CHANGETODEC
; DISPLAY 1 BYTE IN ACC. A AS DECIMAL ON SCREEN
; INPUT:   BYTE IN ACC. A
; RETURN OUTPUT:   NONE
; REGISTER CHANGE: NONE
; MEMORY CHANGE:   NONE
; SIDE EFFECT:     NONE
;============================================

;++++++++++
; SUBROUTINE WILL KEEP DIVIDE 10 AND PUSH REMANINDER
; ON STACK UNTIL RESULT IS LESS THAN 10
; THEN POP EACH DIGIT CHANGE TO ASCII AND DISPALY
;++++++++++
CHANGETODEC:
        PSHA          ;
        PSHB          ; SAVE ACC.
        LDAB  #H'FF   ; USE FFH TO INDEICATE
                      ; END OF NUMBER IN STACK
LOOP:
        PSHB          ; PUSH REMAINDER ON STACK
        CMPA  #9      ; IS RESULT LESS THAN 10
        BLS   FIN     ; YES STOP
        BSR   DIV10   ; ----NO  KEEP DIVIDE
        BRA   LOOP    ; --|

FIN:
        PSHA          ; PUSH LAST DIGIT
LOOP2:
        PULA          ; POP DIGIT
        CMPA  #H'FF   ; LAST DIGIT ?
        BEQ   OUT     ; YES STOP
        ADDA  #H'30   ; ---
        JSR   H'F803  ;   |- NO CHANGE TO ASCII
        BRA   LOOP2   ; --   DISPLAY AND GET NEXT DIGIT
OUT:
        PULB
        PULA          ; RESTORE ACC.
        RTS

;===========================================
; SUBROUTINE SHOWDEC
; DISPLAY 1 BYTE IN ACC. A AS SIGNED DECIMAL ON SCREEN
; INPUT:   BYTE IN ACC. A
; RETURN OUTPUT:   NONE
; REGISTER CHANGE: NONE
; MEMORY CHANGE:   NONE
; SIDE EFFECT:     NONE
;============================================

;++++++++++
; SUBROUTINE WILL CHACK IF NUMBER IS NEGATIVE
; DISPLAY '-' (MINUS SIGN) PERFROM 2'S COMPLEMENT
; TO GET ABS. VALUE THEN USE SUBR. CHANGETODEC
; TO DISPLAY
; IF NUMBER IS POSITIVE USE SUBR. CHANGETODEC
; TO DISPLAY
;++++++++++


SHOWDEC:
        PSHA         ; SAVE OLD VALUE
        CMPA #0      ; IS ACC. POSITIVE
        BGE  DOSHOW  ; YES DISPLAY
        PSHA         ; NO
        LDAA #'-'    ;   DISPLAY '-'
        JSR  H'F803  ;
        PULA         ;
        COMA         ; 2'S COMPLIMENT
        INCA         ; TO GET ABS. VALUE
DOSHOW:
        BSR   CHANGETODEC ; DISPLAY AS DEC.
        PULA         ; GET OLD VALUE
        RTS

        .END
